Option Strict Off

Imports System.Web.UI.WebControls
Imports System.Data.SqlClient
Imports System.Data
Imports System.Configuration


Public Class QSearch
  Inherits System.Web.UI.UserControl
  Protected WithEvents cboVendor As System.Web.UI.WebControls.DropDownList
  Protected WithEvents cboLocation As System.Web.UI.WebControls.DropDownList
  Protected WithEvents cboThru As System.Web.UI.WebControls.DropDownList
  Protected WithEvents txtMessage As System.Web.UI.HtmlControls.HtmlGenericControl
  Protected WithEvents imgSearch As System.Web.UI.HtmlControls.HtmlInputImage

#Region " Web Form Designer Generated Code "

  'This call is required by the Web Form Designer.
  <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

  End Sub

  Protected Sub Page_Init(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
    'CODEGEN: This method call is required by the Web Form Designer
    'Do not modify it using the code editor.
    InitializeComponent()

  End Sub

#End Region

  Private Sub imgSearch_ServerClick(ByVal sender As System.Object, ByVal e As System.Web.UI.ImageClickEventArgs) Handles imgSearch.ServerClick
    ' Now search for the classes and display them in a grid
    If cboVendor.SelectedItem.Value = 0 And cboLocation.SelectedItem.Value = 0 Then
      txtMessage.InnerText = "Please Select a City OR Vendor"
      txtMessage.Style.Item("Color") = "Red"
      Return
    Else
      Response.Redirect("/QuilogyEducation/Schedule.aspx?Vendor=" & cboVendor.SelectedItem.Value & "&Location=" & cboLocation.SelectedItem.Value & "&Advance=" & cboThru.SelectedItem.Value)
    End If
  End Sub

  Private Sub QSearch_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load

    If Not Me.IsPostBack Then
      LoadControls()

      ' Make sure the boxes are reset if needed
      If Not Request("Vendor") Is Nothing Then
        cboVendor.Items.FindByValue(Request("Vendor").ToString).Selected = True
        cboLocation.Items.FindByValue(Request("Location").ToString).Selected = True
        cboThru.Items.FindByValue(Request("Advance").ToString).Selected = True
      Else
        cboLocation.Items.FindByValue("0").Selected = True
        cboVendor.Items.FindByValue("0").Selected = True
      End If
    End If

  End Sub

  Private Sub LoadControls()

    ' Load the drop downs
    cboThru.Items.Add(New ListItem("in 30 days", "30"))
    cboThru.Items.Add(New ListItem("in 60 days", "60"))
    cboThru.Items.Add(New ListItem("in 90 days", "90"))
    cboThru.Items.Add(New ListItem("in 120 days", "120"))
    cboThru.Items.Add(New ListItem("--All--", "0"))
    'cboThru.SelectedIndex = 0

    ' Loads the other drop downs from the database
    ' This doesn't follow the tiered architecture but shows how multiple
    ' result sets can be retrieved from a single stored proc. This techniqueis
    ' application-specific which is why it doesn't follow the architecture

    Dim dr As SqlDataReader
    Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("SQLConnect"))
    Dim cm As New SqlCommand("usp_GetSearch", cn)

    Try

      ' Open the connection and execute the DataReader
      cn.Open()
      cm.CommandType = CommandType.StoredProcedure
      dr = cm.ExecuteReader()

      ' Use Databinding
      With cboVendor
        .DataSource = dr
        .DataTextField = "Name"
        .DataValueField = "VendorID"
        .DataBind()
      End With

      ' Get the next resultset
      dr.NextResult()

      With cboLocation
        .DataSource = dr
        .DataTextField = "City"
        .DataValueField = "LocID"
        .DataBind()
      End With


    Catch E As Exception
      txtMessage.InnerText = "The controls could not be populated: " & E.Message
      txtMessage.Style("Color") = "Red"

    Finally
      ' Cleanup
      If Not dr Is Nothing Then dr.Close()
      'cn.Close()

      ' Now add the items to get all the values
      cboLocation.Items.Add(New ListItem("--All--", 0))
      cboVendor.Items.Add(New ListItem("--All--", 0))
    End Try

  End Sub


End Class
