Option Strict Off

Imports Quilogy.Education
Imports Quilogy.Education.Schedule
Imports System.Configuration
Imports System.Web.UI.WebControls
Imports System.web.UI

Public Class Schedule : Inherits System.Web.UI.Page
    Protected WithEvents dgSchedule As System.Web.UI.WebControls.DataGrid
    Protected WithEvents txtMessage As System.Web.UI.HtmlControls.HtmlGenericControl

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected Sub Page_Init(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()

        ' Allow paging
        dgSchedule.AllowPaging = True
        dgSchedule.PagerStyle.Mode = Web.UI.WebControls.PagerMode.NumericPages
        dgSchedule.PagerStyle.PageButtonCount = 5
        dgSchedule.PageSize = 10
        dgSchedule.AutoGenerateColumns = False
        dgSchedule.AllowSorting = True
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    'Put user code to initialize the page here
    If Not Me.IsPostBack Then
      GetSchedule("")
    End If

    End Sub

  Private Sub GetSchedule(ByVal pSort As String)
    Dim oClasses As Classes
    Dim dsSched As ScheduleData
    Dim flDesc As Boolean = False

    If Not Request("Vendor") Is Nothing Then
      ' Try and get the schedule
      Try
        oClasses = New Classes(ConfigurationSettings.AppSettings("SQLConnect"))
        dsSched = oClasses.GetSchedule(Request("Location"), Request("Vendor"), Request("Advance"))
        dgSchedule.DataSource = dsSched.OfferingsTable.DefaultView

        ' Add to the state bag if not already present
        If Me.ViewState("SortField") Is Nothing Then
          Me.ViewState.Add("SortField", pSort)
          Me.ViewState.Add("SortDesc", True) ' default to true so first time is ASC
        End If

        ' Toggle the sort if we're clicking on the same column
        If pSort <> "" And pSort = Me.ViewState("SortField").ToString Then
          flDesc = Not Me.ViewState("SortDesc")

          If flDesc Then
            pSort = pSort & " DESC"
          Else
            pSort = pSort & " ASC"
          End If
        End If

        ' Set the field and order in the StateBag
        Me.ViewState("SortDesc") = flDesc
        Me.ViewState("SortField") = pSort

        ' Sort the table
        dsSched.OfferingsTable.DefaultView.Sort = pSort
        dgSchedule.DataBind()

      Catch Ex As Exception
        txtMessage().Style.Item("Color") = "Red"
        txtMessage.InnerText = "An error occcured: " & Ex.Message
      End Try

    End If
  End Sub

  Private Sub dgSchedule_SortCommand(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridSortCommandEventArgs) Handles dgSchedule.SortCommand
    ' Sort by the sort expression of the bound column
    GetSchedule(e.SortExpression)
  End Sub

  Private Sub dgSchedule_PageIndexChanged(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridPageChangedEventArgs) Handles dgSchedule.PageIndexChanged
    ' Make sure the page index gets changed to the new page
    dgSchedule.CurrentPageIndex = e.NewPageIndex
    GetSchedule("")
  End Sub

End Class
