Option Strict On

Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports Quilogy.Education
Imports Quilogy.Education.Enrollment
Imports Quilogy.Education.Schedule
Imports System.Xml.Serialization
Imports System.Xml
Imports System.Configuration


<WebService(Namespace:="www.quilogy.com/edservice", _
 Description:="Quilogy's Education Web Service", _
 Name:="QuilogyEducation")> _
Public Class EducationService : Inherits WebService

#Region " Web Services Designer Generated Code "

  'Required by the WebServices Designer
  Private components As System.ComponentModel.Container

  Public Sub New()
    MyBase.New()

    'CODEGEN: This procedure is required by the WebServices Designer
    'Do not modify it using the code editor.
    InitializeComponent()

    'Add your own initialization code after the InitializeComponent call
  End Sub

  Private Sub InitializeComponent()
    'CODEGEN: This procedure is required by the WebServices Designer
    'Do not modify it using the code editor.
    components = New System.ComponentModel.Container()
  End Sub

  Overloads Sub Dispose()
    'CODEGEN: This procedure is required by the WebServices Designer
    'Do not modify it using the code editor.
  End Sub

#End Region
  '***************************************************************
  <WebMethod(Description:="Retrieves a student's transcript", _
    EnableSession:=True)> _
  Public Function GetTranscript() As TranscriptData
    Dim dsTrans As TranscriptData
    Dim objStud As New Students()

    ' Check the incoming argument
    If Session("StudentID") Is Nothing Then
      Throw New ArgumentNullException( _
        "You must login before calling the GetTranscript method")
      Return Nothing
    End If

    ' Call the data access component
    dsTrans = objStud.GetTranscript( _
      Convert.ToInt32(Session("StudentID")))
    Return dsTrans

  End Function

  '***************************************************************
  <WebMethod(Description:="Allows a student to login", EnableSession:=True)> _
  Public Function Login(ByVal EmailAddress As String, _
    ByVal Password As String) As Boolean
    Dim objStud As Students
    Dim dsStud As StudentData
    Dim drStud As DataRow

    ' Check the incoming arguments
    If EmailAddress Is Nothing Or Password Is Nothing Then
      Throw New ArgumentNullException( _
        "You must supply an email address and password")
      Return False
    End If

    ' Call the data access component
    objStud = New Students()
    dsStud = objStud.Login(EmailAddress, Password)

    If Not dsStud Is Nothing Then
      ' Extract the student ID
      drStud = dsStud.StudentTable.Rows(0)
      Session("StudentID") = drStud(StudentData.STUDENT_ID)
      Return True
    Else
      Throw New Exception( _
        "Student is not registered or credentials were incorrect")
      Return False
    End If

  End Function

  '***************************************************************
  <WebMethod( _
    Description:="Retrieves a course schedule")> _
  Public Function GetSchedule( _
    ByVal Location As String, _
    ByVal Vendor As String, _
    ByVal DaysOut As Byte) As ScheduleData

    Dim objClasses As New Classes( _
      ConfigurationSettings.AppSettings("SQLConnect"))
    Dim intLocID As Integer
    Dim intVendorID As Integer
    Dim dsSched As ScheduleData

    ' Translate the arguments
    Select Case Location
      Case "St. Louis", "STL"
        intLocID = 4
      Case "Kansas City", "KC"
        intLocID = 1
      Case "Des Moines", "DSM"
        intLocID = 2
      Case "Omaha", "OMA"
        intLocID = 3
      Case "Nashville", "NSH"
        intLocID = 5
      Case Else
        intLocID = 0 'All cities
    End Select
    Select Case Vendor
      Case "Microsoft", "MSFT"
        intVendorID = 1
      Case "Oracle"
        intVendorID = 4
      Case "Sybase", "SYB"
        intVendorID = 2
      Case Else
        intVendorID = 0
    End Select

    ' Call the data access component
    dsSched = objClasses.GetSchedule(intLocID, intVendorID, DaysOut)
    Return dsSched
  End Function

End Class
