Option Strict Off

Imports Quilogy.Education.Enrollment
Imports Quilogy.Education
Imports Quilogy.Education.Schedule
Imports System.Configuration
Imports System.Web.Caching

Public Class Register
    Inherits System.Web.UI.Page
    Protected WithEvents cmdSubmit As System.Web.UI.WebControls.Button
    Protected WithEvents txtWho As System.Web.UI.HtmlControls.HtmlGenericControl
    Protected WithEvents txtCourse As System.Web.UI.HtmlControls.HtmlGenericControl
    Protected WithEvents txtCost As System.Web.UI.HtmlControls.HtmlGenericControl
    Protected WithEvents txtMessage As System.Web.UI.HtmlControls.HtmlGenericControl
    Protected WithEvents txtWhen As System.Web.UI.HtmlControls.HtmlGenericControl

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThroughAttribute()> Private Sub InitializeComponent()

    End Sub

    Protected Sub Page_Init(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

  Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' Load the controls
    If Not Me.IsPostBack Then
      If Request("ClassID") Is Nothing Then
        txtWho.InnerText = "No class was picked. Search again"
        txtWho.Style.Item("Color") = "Red"
        Return
      End If

      ' Now display the class
      txtWhen.InnerText = Request("When").ToString
      txtCourse.InnerText = Request("Course").ToString
      txtWho.InnerText = Session("StudentName").ToString

      ' Calculate the cost for display
      Dim oClasses As New Classes(ConfigurationSettings.AppSettings("SQLConnect"))
      Dim decCost As Decimal

      decCost = oClasses.CalcCost(Request("ClassID"), RegistrationType.Web)
      txtCost.InnerText = FormatCurrency(decCost, 0, TriState.False, TriState.False, TriState.False)

      ' Add the quote to the cache
      Cache.Insert(Session("StudentID"), decCost, Nothing, Cache.NoAbsoluteExpiration, TimeSpan.FromSeconds(20))
      Context.Trace.Write("Cache", "Cache=" & Cache(Session("StudentID")))

    End If

  End Sub

  Private Sub cmdSubmit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSubmit.Click
    Dim oReg As Registration
    Dim dsEnroll As New EnrollmentData()
    Dim dr As DataRow
    Dim drStud As DataRow
    Dim intEnrollID As Integer

    ' First make sure the course quote has not expired
    If Cache(Session("StudentID")) Is Nothing Then
      txtMessage.InnerText = "Sorry. The price quote has expired. Please reselect your class and register within 20 seconds."
      cmdSubmit.Visible = False
      Return
    End If

    ' Would redirect here to process payment type and then insert the enrollment

    Try
      oReg = New Registration(ConfigurationSettings.AppSettings("SQLConnect"))

      ' Build the enrollment DataSet
      dr = dsEnroll.EnrollmentTable.NewRow
      dr(dsEnroll.CLASS_ID) = Request("ClassID")
      dr(dsEnroll.WEB_ENROLL) = "Y"
      dr(dsEnroll.PAYMENT_TYPE) = "CC"
      dsEnroll.EnrollmentTable.Rows.Add(dr)
      drStud = dsEnroll.Tables("Student").NewRow
      drStud(EnrollmentData.STUDENT_ID) = Session("StudentID")
      drStud(EnrollmentData.LAST_NAME) = "Dummy" ' Placeholder since it cannot be null
      dsEnroll.Tables("Student").Rows.Add(drStud)
      drStud.SetParentRow(dr)

      ' Register the Student
      intEnrollID = oReg.RegisterStudent(dsEnroll)
      If intEnrollID > 0 Then
        txtMessage.InnerText = "Registration Taken Successfully. Thank You"
        cmdSubmit.Visible = False
      End If

    Catch Ex As Exception
      txtMessage.InnerText = "An error occurred: " & Ex.Message
      txtMessage.Style.Item("Color") = "Red"
    End Try

  End Sub
End Class
