Option Strict Off

Imports System.Drawing
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports Quilogy.Education
Imports Quilogy.Education.Enrollment
Imports System.Data
Imports System.Configuration
Imports System.Web.Security


Public Class studentprofile
    Inherits System.Web.UI.Page
    Protected WithEvents txtLName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtPhone As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtFName As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtCity As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtEmail As System.Web.UI.WebControls.TextBox
    Protected WithEvents cmdSave As System.Web.UI.WebControls.Button
    Protected WithEvents txtZip As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtState As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtOrg As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtAddress As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtMessage As System.Web.UI.HtmlControls.HtmlGenericControl

    Protected mdsStud As StudentData
    Protected WithEvents LNameValidator As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents ValidationSummary As System.Web.UI.WebControls.ValidationSummary
    Protected WithEvents EmailValidator As System.Web.UI.WebControls.RequiredFieldValidator
    Protected WithEvents ZipValidator As System.Web.UI.WebControls.RegularExpressionValidator
    Protected WithEvents EmailAtValidator As System.Web.UI.WebControls.RegularExpressionValidator
    Protected WithEvents PhoneValidator As System.Web.UI.WebControls.RegularExpressionValidator
    Protected mdrStud As DataRow
    

#Region " Web Forms Designer Generated Code "
    
    'CODEGEN: This procedure is required by the Web Form Designer
    'Do not modify it using the code editor.
    Private Sub InitializeComponent()

    End Sub

#End Region

    Protected Sub Page_Init(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        If Not Me.IsPostBack Then
            If Context.User.Identity.IsAuthenticated Then
                ' Go get the studentData
                Dim oStud As New Students(ConfigurationSettings.AppSettings("SQLConnect").ToString)
                mdsStud = oStud.GetStudent(Session("StudentID"))
                mdrStud = mdsStud.StudentTable.Rows(0)
                txtMessage().InnerText = "Profile for " & Session("StudentName")
            Else
                ' Create an empty StudentData DataSet with a single row
                mdsStud = New StudentData()
                mdrStud = mdsStud.StudentTable.NewRow
                txtMessage().InnerText = "To become a registered user enter your info and click Save."
            End If

            ' Bind all of the controls on the page
            Me.DataBind()
        End If

    End Sub

    Protected Sub cmdSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSave.Click
        Dim intStudentID As Integer
        Dim oStud As Students
        Dim dsStud As StudentData
        Dim dr As DataRow

        ' First see if the form is valid
        If Not Me.IsValid Then
            Return
        End If

        ' Place the data into the DataSet 
        dsStud = FillDs()

        Try
            ' Create the student object
            Dim strConnect As String
            strConnect = ConfigurationSettings.AppSettings("SQLConnect").ToString
            oStud = New Students(strConnect)

            ' Save the student data
            intStudentID = oStud.Save(dsStud)

            If intStudentID > 0 Then
                txtMessage().InnerText = "Profile Successfully Saved."
                txtMessage().Style.Item("Color") = "Green"

                ' If they're a new student then setup their session and authentication
                If Session("StudentID") Is Nothing Then
                    txtMessage().InnerText &= " Your password has been set to your email address."
                    Session("StudentID") = intStudentID
                    ' Set the authentication cookie
                    FormsAuthentication.SetAuthCookie(txtEmail.Text, False)
                End If

                dr = dsStud.StudentTable.Rows(0)
                Session("StudentName") = dr(StudentData.FIRST_NAME).ToString & " " & _
                    dr(StudentData.LAST_NAME).ToString
                cmdSave.Visible = False
                Return
            End If

        Catch Ex As Exception
            txtMessage().InnerText = "An error occurred: " & Ex.Message
            txtMessage().Style.Item("Color") = "Red"
        End Try

    End Sub

    Private Function FillDs() As StudentData
        Dim dr As DataRow
        Dim dsStud As New StudentData()

        Try
            dr = dsStud.StudentTable.NewRow

            If Not Session("StudentID") Is Nothing Then
                dr(StudentData.STUDENT_ID) = Session("StudentID")
            End If

            dr(StudentData.FIRST_NAME) = txtFName.Text
            dr(StudentData.LAST_NAME) = txtLName.Text
            dr(StudentData.ORGANIZATION) = txtOrg.Text
            dr(StudentData.ADDRESS) = txtAddress.Text
            dr(StudentData.CITY) = txtCity.Text
            dr(StudentData.STATE) = txtState.Text
            dr(StudentData.EMAIL) = txtEmail.Text
            dr(StudentData.PHONE) = txtPhone.Text
            dr(StudentData.ZIP_CODE) = txtZip.Text

            ' Add the row to the DataSet if building it
            dsStud.StudentTable.Rows.Add(dr) ' Note that this will validate data entry as well
            Return dsStud

        Catch e As Exception
            txtMessage().InnerText = "An error occurred: " & e.Message
            txtMessage().Style.Item("Color") = "Red"
        End Try

    End Function

End Class
